#ifndef MINUTERIE_H
#define MINUTERIE_H

#include <windows.h>

class Stoppeur
{
   HANDLE m_EvenementFin;
   bool m_DoitArreter;
   bool m_EstArrete;
   bool m_EstLance;
   HANDLE m_ThHandle;
public:
   bool GetDoitArreter () const { return m_DoitArreter; }
   bool GetEstArrete () const { return m_EstArrete; }
   void DemandeArret () { m_DoitArreter = true; ::SetEvent (m_EvenementFin); }
   void AttendreArret () { ::WaitForSingleObject (m_EvenementFin, INFINITE); }
   void EstArrete () { m_EstArrete = true; }
   Stoppeur ()
      : m_DoitArreter (false), m_EstArrete (false), m_EstLance (false),
        m_ThHandle (0), m_EvenementFin (::CreateEvent (0, FALSE, FALSE, 0)) { }
   void Associer (const HANDLE ThH) { m_ThHandle = ThH; }
   void Lancer ()
   {
      if (m_ThHandle && !m_EstLance)
      {
         ::ResumeThread (m_ThHandle);
         m_EstLance = true;
      }
   }
   virtual ~Stoppeur () { ::CloseHandle (m_ThHandle); }
};


class Minuterie : public Stoppeur
{
   static const int INTERVALLE_MINIMAL;
   int m_Intervalle;
public:
   Minuterie (const int Intervalle = INTERVALLE_MINIMAL);
   virtual ~Minuterie ();
   virtual void Tic () = 0;
   int GetIntervalle () const { return m_Intervalle; }
   void SetIntervalle (const int Intervalle);
};

#endif // !defined MINUTERIE_H
