#include <GestionnaireDeVerrou.h>
#include <Mutex.h>
#include <Autoverrou.h>

GestionnaireDeVerrou GestionnaireDeVerrou::Singleton;

GestionnaireDeVerrou::GestionnaireDeVerrou()
   : m_CptVerrou (0), m_Mutex (new Mutex ()),
     m_FinContexte (CreateEvent (0, FALSE, FALSE, 0))
{
}

void GestionnaireDeVerrou::Incrementer()
{
   Autoverrou a(*m_Mutex);
   m_CptVerrou++;
}

void GestionnaireDeVerrou::Decrementer()
{
   Autoverrou a(*m_Mutex);
   m_CptVerrou--;
   if (EstVide ()) SetEvent (m_FinContexte);
}

bool GestionnaireDeVerrou::EstVide() const
{
   return m_CptVerrou == 0;
}

GestionnaireDeVerrou::~GestionnaireDeVerrou()
{
   delete m_Mutex;
   ::CloseHandle (m_FinContexte);
}

void GestionnaireDeVerrou::AttendreLaFin ()
{
   ::WaitForSingleObject (m_FinContexte, INFINITE);
}

