#define _WIN32_DCOM

#include "Minuterie.h"
#include <windows.h>
#include <iostream>
#include <ChargeurCOM.h>

const int Minuterie::INTERVALLE_MINIMAL = 1;

// Thread qui itre et fait accomplir  la minuterie qui lui
// est affecte la tche qui lui est dvolue (polymorphisme)
namespace
{
   unsigned long __stdcall Execute (void *);
}


void Minuterie::SetIntervalle (const int Intervalle)
{
   m_Intervalle = max (Intervalle, INTERVALLE_MINIMAL);
}

Minuterie::Minuterie (const int Intervalle) : Stoppeur ()
{
   SetIntervalle (Intervalle);
   DWORD idTh;
   HANDLE hTh = ::CreateThread (0, 0, Execute, reinterpret_cast<void *> (this),
                                CREATE_SUSPENDED, &idTh);
   Associer (hTh);
}

Minuterie::~Minuterie ()
{
   DemandeArret ();
   while (!GetEstArrete ()) ::Sleep (0);
}

unsigned long __stdcall ::Execute (void *p)
{
   ChargeurCOM ccom;
   int NbItt = 0;
   unsigned long _PlusRecentTic = ::GetTickCount ();
   Minuterie *m = reinterpret_cast<Minuterie *> (p);
   while (! m->GetDoitArreter ())
   {
      unsigned long _TickCount = ::GetTickCount ();
      long NbTicsDepuis = _TickCount - _PlusRecentTic;

      if (NbTicsDepuis >= m->GetIntervalle ())
      {
         unsigned long NbTicsAFaire = NbTicsDepuis / m->GetIntervalle ();
         while (NbTicsAFaire-- > 0) m->Tic ();
         _PlusRecentTic = _TickCount;
      }
      else if (NbTicsDepuis < 0) // quand on aura un dbordement...
         _PlusRecentTic = _TickCount;
      ::Sleep (1);
      NbItt ++;
   }
   m->EstArrete ();
   return 0L;
}

